﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OZX
{
    public class OzPDU_OZX_Send : OzPDU_OZX
    {

        //**********************************
        // Command ID
        //**********************************

        public override byte GetCommandID()
        {
            return Send; 
        }

        //**********************************
        // Data
        //**********************************

        public IOzxMessage Message;

        //**********************************
        // Construct
        //**********************************
        public OzPDU_OZX_Send()
        {
            Message = OzxMessageFactory.Instance.Create();
        }

        //**********************************
        // Encode
        //**********************************
        protected override byte[] EncodeData()
        {
            var messageBytes = OzCommonBytes.MessageToBytes(Message);
            return messageBytes;
        }

        //**********************************
        // DecodeData
        //**********************************

        protected override void DecodeData(byte[] src, ref int offset)
        {
            Message = OzCommonBytes.BytesToMessage(src, ref offset);
        }
    }
}
