﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OZX
{
    public class OzPDU_OZX_Send_SubmitSuccess : OzPDU_OZX
    {

        //**********************************
        // Command ID
        //**********************************

        public override byte GetCommandID()
        {
            return Send_Success; 
        }

        //**********************************
        // Data
        //**********************************

        public string MessageID;
        public DateTime SendDate;

        //**********************************
        // Encode
        //**********************************
        protected override byte[] EncodeData()
        {
            var messageIDBytes = OzCommonBytes.StringToBytes(MessageID);
            var sendDateBytes = OzCommonBytes.DateToBytes(SendDate);

            var ret = new byte[messageIDBytes.Length + sendDateBytes.Length];
            Buffer.BlockCopy(messageIDBytes, 0, ret, 0, messageIDBytes.Length);
            Buffer.BlockCopy(sendDateBytes, 0, ret, messageIDBytes.Length, sendDateBytes.Length);

            return ret;
        }

        //**********************************
        // DecodeData
        //**********************************
        protected override void DecodeData(byte[] src, ref int offset)
        {
            MessageID = OzCommonBytes.BytesToString(src, ref offset);
            SendDate = OzCommonBytes.BytesToDate(src, ref offset);
        }
    }
}
